# -*- coding: utf-8 -*-
"""
the only dialog of this plugin - holds the userarea and
handles GUI interaction
"""


import c4d

from smartpolychart import ids
from smartpolychart import worker
from smartpolychart import canvas


class MainDialog(c4d.gui.GeDialog):

    userarea = None

    # called once when the dialog is initialized
    def __init__(self):

        # kill the menu-bar
        self.AddGadget(c4d.DIALOG_NOMENUBAR, ids.MAINDIALOG)

        # init the userarea
        self.userarea = canvas.Canvas()

    # called when the dialog is opened - load or generate the GUI here
    def CreateLayout(self):

        # load and parse the dialog layout from the resource file
        self.LoadDialogResource(ids.MAINDIALOG,
                                None,
                                flags = c4d.BFH_SCALEFIT | c4d.BFV_SCALEFIT)

        #attach the userarea gadget
        self.AttachUserArea(self.userarea,
                            ids.MAINDIALOG_USERAREA,
                            c4d.USERAREA_COREMESSAGE)

        #update the userarea
        self.update()

        return True

    # called on every GUI-interaction - check the 'id' against those of
    #your GUI elements
    def Command(self, id, msg):

        if id == ids.MAINDIALOG_BTN_UPDATE:
            #update the userarea
            self.update()

            return True

        return False

    # redraws the canvas with the data returned from our worker
    def update(self):

        self.userarea.draw(worker.work())
