# -*- coding: utf-8 -*-
"""
a simple worker to recurse through the scene
this code could also have been part of maindialog.py oder canvas.py
"""


from operator import itemgetter

import c4d
from c4d import documents


# walks the actual document to find all Opolygon objects
def work():

    # get the active document and die if there is none
    doc = documents.GetActiveDocument()
    if doc is None: return False
        
    # call the walker with the first object of the scene    
    return getObj(doc.GetFirstObject())    
    
# this will walk all objects on the same level as the given one and call
#itself recursively for any children
def getObj(aObj):
    
    result = []
    
    # as long as the object is not None...    
    while aObj:
        # check of there is a child and recurse...
        if aObj.GetDown() :
            result += getObj(aObj.GetDown())
        
        # we found a polygon object!
        if aObj.CheckType(c4d.Opolygon):
            # we store polycount, name and a reference...
            result.append([aObj.GetPolygonCount(), aObj.GetName(), aObj])
        
        # ...and on to the next object...
        aObj = aObj.GetNext()
            
    # and finally we return a list sorted by the first column 
    return sorted(result, key=itemgetter(0), reverse = True)